var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React, { forwardRef } from 'react';
import PropTypes from 'prop-types';
import cn from 'classnames';

import iconSizes from '../../utils/iconSizes';

var Icon = forwardRef(function (_ref, ref) {
  var _cn;

  var name = _ref.name,
      size = _ref.size,
      rotate = _ref.rotate,
      fixedWidth = _ref.fixedWidth,
      spin = _ref.spin,
      pulse = _ref.pulse,
      props = _objectWithoutProperties(_ref, ['name', 'size', 'rotate', 'fixedWidth', 'spin', 'pulse']);

  return React.createElement('i', _extends({
    ref: ref
  }, props, {
    className: cn('fa', 'fa-' + name, (_cn = {
      'fa-fw': fixedWidth,
      'fa-spin': spin,
      'fa-pulse': pulse
    }, _cn['fa-' + size] = size, _cn['fa-rotate-' + rotate] = rotate, _cn), props.className)
  }));
});

Icon.displayName = 'Icon';

Icon.propTypes = {
  className: PropTypes.string,
  fixedWidth: PropTypes.bool,
  name: PropTypes.string,
  pulse: PropTypes.bool,
  rotate: PropTypes.oneOf(['', '90', '180', '270']),
  size: PropTypes.oneOf(iconSizes),
  spin: PropTypes.bool
};

Icon.defaultProps = {
  className: undefined,
  fixedWidth: false,
  name: 'question',
  pulse: false,
  rotate: '',
  size: '',
  spin: false
};

export default Icon;