var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React, { forwardRef } from 'react';
import PropTypes from 'prop-types';
import cn from 'classnames';

import Item from './Item';

import './index.css';

var List = forwardRef(function (_ref, ref) {
  var Tag = _ref.tag,
      flush = _ref.flush,
      props = _objectWithoutProperties(_ref, ['tag', 'flush']);

  return React.createElement(Tag, _extends({
    ref: ref
  }, props, {
    className: cn('list-group text-body', { 'list-group-flush': flush }, props.className)
  }));
});

List.propTypes = {
  className: PropTypes.string,
  flush: PropTypes.bool,
  tag: PropTypes.oneOfType([PropTypes.func, PropTypes.string])
};

List.defaultProps = {
  className: undefined,
  flush: false,
  tag: 'ul'
};

List.Item = Item;

export default List;