var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React, { forwardRef } from 'react';
import PropTypes from 'prop-types';
import cn from 'classnames';

import sizes from '../../utils/sizes';

var Select = forwardRef(function (_ref, ref) {
  var items = _ref.items,
      size = _ref.size,
      className = _ref.className,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ['items', 'size', 'className', 'children']);

  return React.createElement(
    'select',
    _extends({ ref: ref }, props, { className: cn('custom-select', 'form-control-' + size, className) }),
    children || items.map(function (_ref2, index) {
      var _ref2$id = _ref2.id,
          id = _ref2$id === undefined ? '' : _ref2$id,
          _ref2$value = _ref2.value,
          value = _ref2$value === undefined ? '' : _ref2$value,
          _ref2$name = _ref2.name,
          name = _ref2$name === undefined ? '' : _ref2$name,
          _ref2$disabled = _ref2.disabled,
          disabled = _ref2$disabled === undefined ? false : _ref2$disabled;
      return React.createElement(
        'option',
        { key: index, value: id || value, disabled: disabled },
        name
      );
    })
  );
});

Select.displayName = 'Select';

Select.propTypes = {
  children: PropTypes.node,
  className: PropTypes.string,
  items: PropTypes.arrayOf(PropTypes.shape({
    id: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
    value: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
    name: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
    disabled: PropTypes.bool
  })),
  size: PropTypes.oneOf(sizes)
};

Select.defaultProps = {
  children: null,
  className: undefined,
  items: [],
  size: 'md'
};

export default Select;