var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cn from 'classnames';

var Item = function Item(_ref) {
  var title = _ref.title,
      active = _ref.active,
      className = _ref.className,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ['title', 'active', 'className', 'children']);

  return React.createElement(
    'div',
    _extends({}, props, { className: cn({ 'd-none': !active }, className) }),
    children
  );
};

Item.propTypes = process.env.NODE_ENV !== "production" ? {
  title: PropTypes.oneOfType([PropTypes.string, PropTypes.node]),
  active: PropTypes.bool,
  className: PropTypes.string,
  children: PropTypes.node
} : {};

Item.defaultProps = {
  title: '',
  active: false,
  className: '',
  children: null
};

export default Item;