var _class, _temp2;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { PureComponent } from 'react';
import { findDOMNode } from 'react-dom';
import PropTypes from 'prop-types';
import Reference from './Reference';
import Content from './Content';
import { Provider } from './context';

var Tooltip = (_temp2 = _class = function (_PureComponent) {
  _inherits(Tooltip, _PureComponent);

  function Tooltip() {
    var _temp, _this, _ret;

    _classCallCheck(this, Tooltip);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _PureComponent.call.apply(_PureComponent, [this].concat(args))), _this), _this.state = {
      showContent: false,
      referenceNode: null
    }, _this.setReferenceNode = function (node) {
      return _this.setState({ referenceNode: findDOMNode(node) });
    }, _this.handleMouseEnter = function () {
      return _this.setState({ showContent: true });
    }, _this.hideMouseLeave = function () {
      return _this.setState({ showContent: false });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  // eslint-disable-next-line react/no-find-dom-node


  Tooltip.prototype.render = function render() {
    var context = {
      showContent: this.state.showContent,
      placement: this.props.placement,
      referenceNode: this.state.referenceNode,
      setReferenceNode: this.setReferenceNode,
      onMouseEnter: this.handleMouseEnter,
      onMouseLeave: this.hideMouseLeave
    };
    return React.createElement(
      Provider,
      { value: context },
      this.props.children
    );
  };

  return Tooltip;
}(PureComponent), _class.defaultProps = {
  placement: 'top'
}, _class.Reference = Reference, _class.Content = Content, _temp2);
Tooltip.propTypes = process.env.NODE_ENV !== "production" ? {
  placement: PropTypes.oneOf(['top', 'left', 'bottom', 'right']),
  children: PropTypes.node.isRequired
} : {};


export default Tooltip;