'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _createComponent = require('../../utils/createComponent');

var _createComponent2 = _interopRequireDefault(_createComponent);

var _buttonColors = require('../../utils/buttonColors');

var _buttonColors2 = _interopRequireDefault(_buttonColors);

var _sizes = require('../../utils/sizes');

var _sizes2 = _interopRequireDefault(_sizes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Button = (0, _react.forwardRef)(function (_ref, ref) {
  var tag = _ref.tag,
      type = _ref.type,
      active = _ref.active,
      outline = _ref.outline,
      color = _ref.color,
      size = _ref.size,
      props = _objectWithoutProperties(_ref, ['tag', 'type', 'active', 'outline', 'color', 'size']);

  var Tag = props.href && tag === 'button' ? 'a' : tag;

  var className = (0, _classnames2.default)('btn', 'btn-' + size, 'btn' + (outline ? '-outline' : '') + '-' + color, { active: active, disabled: props.disabled }, props.className);

  return _react2.default.createElement(Tag, _extends({ ref: ref }, props, Tag === 'button' ? { type: type } : {}, { className: className }));
});

Button.displayName = 'Button';

Button.propTypes = process.env.NODE_ENV !== "production" ? {
  active: _propTypes2.default.bool,
  className: _propTypes2.default.string,
  color: _propTypes2.default.oneOf(_buttonColors2.default),
  disabled: _propTypes2.default.bool,
  href: _propTypes2.default.string,
  outline: _propTypes2.default.bool,
  size: _propTypes2.default.oneOf(_sizes2.default),
  tag: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.string]),
  type: _propTypes2.default.string
} : {};

Button.defaultProps = {
  active: false,
  className: undefined,
  color: 'primary',
  disabled: false,
  href: undefined,
  outline: false,
  size: 'md',
  tag: 'button',
  type: 'button'
};

Button.Group = (0, _createComponent2.default)('Button.Group', 'btn-group');

Button.Toolbar = (0, _createComponent2.default)('Button.Toolbar', 'btn-toolbar');

exports.default = Button;
module.exports = exports['default'];