'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _iconSizes = require('../../utils/iconSizes');

var _iconSizes2 = _interopRequireDefault(_iconSizes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Icon = (0, _react.forwardRef)(function (_ref, ref) {
  var _cn;

  var name = _ref.name,
      size = _ref.size,
      rotate = _ref.rotate,
      fixedWidth = _ref.fixedWidth,
      spin = _ref.spin,
      pulse = _ref.pulse,
      props = _objectWithoutProperties(_ref, ['name', 'size', 'rotate', 'fixedWidth', 'spin', 'pulse']);

  return _react2.default.createElement('i', _extends({
    ref: ref
  }, props, {
    className: (0, _classnames2.default)('fa', 'fa-' + name, (_cn = {
      'fa-fw': fixedWidth,
      'fa-spin': spin,
      'fa-pulse': pulse
    }, _cn['fa-' + size] = size, _cn['fa-rotate-' + rotate] = rotate, _cn), props.className)
  }));
});

Icon.displayName = 'Icon';

Icon.propTypes = {
  className: _propTypes2.default.string,
  fixedWidth: _propTypes2.default.bool,
  name: _propTypes2.default.string,
  pulse: _propTypes2.default.bool,
  rotate: _propTypes2.default.oneOf(['', '90', '180', '270']),
  size: _propTypes2.default.oneOf(_iconSizes2.default),
  spin: _propTypes2.default.bool
};

Icon.defaultProps = {
  className: undefined,
  fixedWidth: false,
  name: 'question',
  pulse: false,
  rotate: '',
  size: '',
  spin: false
};

exports.default = Icon;
module.exports = exports['default'];