'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _buttonColors = require('../../utils/buttonColors');

var _buttonColors2 = _interopRequireDefault(_buttonColors);

var _sizes = require('../../utils/sizes');

var _sizes2 = _interopRequireDefault(_sizes);

require('./File.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var File = (0, _react.forwardRef)(function (_ref, ref) {
  var id = _ref.id,
      color = _ref.color,
      outline = _ref.outline,
      size = _ref.size,
      disabled = _ref.disabled,
      className = _ref.className,
      style = _ref.style,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ['id', 'color', 'outline', 'size', 'disabled', 'className', 'style', 'children']);

  return _react2.default.createElement(
    'label',
    {
      htmlFor: id,
      className: (0, _classnames2.default)('btn', 'btn-file', 'btn-' + size, 'btn' + (outline ? '-outline' : '') + '-' + color, { disabled: disabled }, className),
      style: style
    },
    children,
    _react2.default.createElement('input', _extends({ ref: ref }, props, { id: id, type: 'file', disabled: disabled }))
  );
});

File.displayName = 'Input.File';

File.propTypes = {
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  color: _propTypes2.default.oneOf(_buttonColors2.default),
  disabled: _propTypes2.default.bool,
  id: _propTypes2.default.string.isRequired,
  outline: _propTypes2.default.bool,
  size: _propTypes2.default.oneOf(_sizes2.default),
  style: _propTypes2.default.object // eslint-disable-line react/forbid-prop-types
};

File.defaultProps = {
  children: null,
  className: undefined,
  color: 'primary',
  disabled: false,
  outline: false,
  size: 'md',
  style: {}
};

exports.default = File;
module.exports = exports['default'];