'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _popper = require('popper.js');

var _popper2 = _interopRequireDefault(_popper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Popper = function (_Component) {
  _inherits(Popper, _Component);

  function Popper() {
    var _temp, _this, _ret;

    _classCallCheck(this, Popper);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = {
      placement: _this.props.placement
    }, _this.popper = null, _this.popperNode = null, _this.arrowNode = null, _this.initPopper = function () {
      _this.popper = new _popper2.default(_this.props.reference, _this.popperNode, {
        placement: _this.props.placement,
        modifiers: {
          arrow: {
            element: _this.arrowNode
          },
          updateState: {
            enabled: true,
            order: 900,
            fn: function fn(data) {
              if (data.placement !== _this.state.placement) {
                _this.setState({ placement: data.placement });
              }
              return data;
            }
          }
        }
      });
    }, _this.updatePopper = function () {
      if (_this.popper) {
        _this.popper.update();
      }
    }, _this.destroyPopper = function () {
      if (_this.popper) {
        _this.popper.destroy();
      }
    }, _this.setPopperNode = function (node) {
      _this.popperNode = node;
    }, _this.setArrowNode = function (node) {
      _this.arrowNode = node;
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  Popper.prototype.componentDidMount = function componentDidMount() {
    this.initPopper();
  };

  Popper.prototype.componentDidUpdate = function componentDidUpdate() {
    this.updatePopper();
  };

  Popper.prototype.componentWillUnmount = function componentWillUnmount() {
    this.destroyPopper();
  };

  Popper.prototype.render = function render() {
    var _props = this.props,
        onMouseEnter = _props.onMouseEnter,
        onMouseLeave = _props.onMouseLeave,
        children = _props.children;
    var placement = this.state.placement;


    return _react2.default.createElement(
      'div',
      {
        ref: this.setPopperNode,
        className: 'popover bs-popover-' + placement,
        role: 'tooltip',
        onMouseEnter: onMouseEnter,
        onMouseLeave: onMouseLeave
      },
      _react2.default.createElement('div', { ref: this.setArrowNode, className: 'arrow' }),
      _react2.default.createElement(
        'div',
        { className: 'popover-body' },
        children
      )
    );
  };

  return Popper;
}(_react.Component);

Popper.propTypes = process.env.NODE_ENV !== "production" ? {
  placement: _propTypes2.default.oneOf(['top', 'left', 'bottom', 'right']).isRequired,
  reference: _propTypes2.default.instanceOf(Element).isRequired,
  onMouseEnter: _propTypes2.default.func.isRequired,
  onMouseLeave: _propTypes2.default.func.isRequired,
  children: _propTypes2.default.node.isRequired
} : {};
exports.default = Popper;
module.exports = exports['default'];