'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _sizes = require('../../utils/sizes');

var _sizes2 = _interopRequireDefault(_sizes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Select = (0, _react.forwardRef)(function (_ref, ref) {
  var items = _ref.items,
      size = _ref.size,
      className = _ref.className,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ['items', 'size', 'className', 'children']);

  return _react2.default.createElement(
    'select',
    _extends({ ref: ref }, props, { className: (0, _classnames2.default)('custom-select', 'form-control-' + size, className) }),
    children || items.map(function (_ref2, index) {
      var _ref2$id = _ref2.id,
          id = _ref2$id === undefined ? '' : _ref2$id,
          _ref2$value = _ref2.value,
          value = _ref2$value === undefined ? '' : _ref2$value,
          _ref2$name = _ref2.name,
          name = _ref2$name === undefined ? '' : _ref2$name,
          _ref2$disabled = _ref2.disabled,
          disabled = _ref2$disabled === undefined ? false : _ref2$disabled;
      return _react2.default.createElement(
        'option',
        { key: index, value: id || value, disabled: disabled },
        name
      );
    })
  );
});

Select.displayName = 'Select';

Select.propTypes = {
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  items: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    id: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
    value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
    name: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
    disabled: _propTypes2.default.bool
  })),
  size: _propTypes2.default.oneOf(_sizes2.default)
};

Select.defaultProps = {
  children: null,
  className: undefined,
  items: [],
  size: 'md'
};

exports.default = Select;
module.exports = exports['default'];