'use strict';

exports.__esModule = true;

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Reference = require('./Reference');

var _Reference2 = _interopRequireDefault(_Reference);

var _Content = require('./Content');

var _Content2 = _interopRequireDefault(_Content);

var _context = require('./context');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Tooltip = (_temp2 = _class = function (_PureComponent) {
  _inherits(Tooltip, _PureComponent);

  function Tooltip() {
    var _temp, _this, _ret;

    _classCallCheck(this, Tooltip);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _PureComponent.call.apply(_PureComponent, [this].concat(args))), _this), _this.state = {
      showContent: false,
      referenceNode: null
    }, _this.setReferenceNode = function (node) {
      return _this.setState({ referenceNode: (0, _reactDom.findDOMNode)(node) });
    }, _this.handleMouseEnter = function () {
      return _this.setState({ showContent: true });
    }, _this.hideMouseLeave = function () {
      return _this.setState({ showContent: false });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  // eslint-disable-next-line react/no-find-dom-node


  Tooltip.prototype.render = function render() {
    var context = {
      showContent: this.state.showContent,
      placement: this.props.placement,
      referenceNode: this.state.referenceNode,
      setReferenceNode: this.setReferenceNode,
      onMouseEnter: this.handleMouseEnter,
      onMouseLeave: this.hideMouseLeave
    };
    return _react2.default.createElement(
      _context.Provider,
      { value: context },
      this.props.children
    );
  };

  return Tooltip;
}(_react.PureComponent), _class.defaultProps = {
  placement: 'top'
}, _class.Reference = _Reference2.default, _class.Content = _Content2.default, _temp2);
Tooltip.propTypes = process.env.NODE_ENV !== "production" ? {
  placement: _propTypes2.default.oneOf(['top', 'left', 'bottom', 'right']),
  children: _propTypes2.default.node.isRequired
} : {};
exports.default = Tooltip;
module.exports = exports['default'];