'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var createComponent = function createComponent(displayName, className) {
  var Component = (0, _react.forwardRef)(function (_ref, ref) {
    var Tag = _ref.tag,
        props = _objectWithoutProperties(_ref, ['tag']);

    return _react2.default.createElement(Tag, _extends({ ref: ref }, props, { className: (0, _classnames2.default)(className, props.className) }));
  });

  Component.displayName = displayName;

  Component.propTypes = {
    className: _propTypes2.default.string,
    tag: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.string])
  };

  Component.defaultProps = {
    className: undefined,
    tag: 'div'
  };

  return Component;
};

exports.default = createComponent;
module.exports = exports['default'];